#include "rc.h"
#include <string.h>


#define	SCK_SET(x)		(x ? (P2OUT |= SCL) : (P2OUT &= ~SCL))			//sck output
#define	READ_SDA()		(P2IN & SDA)									//sda input
#define	MODE_A			0x01
#define	MODE_B		0x02

byte dataBuf[4];			//tempreture_H,tempreture_L,humidity,crc_checksum
byte bit_num;
byte byte_num;
byte f_level;
byte sample_cnt;
byte workMode = MODE_B;	//after power on if no manually select mode, th01 will default work in b mode 
byte f_rasing_edge = 0;
byte f_syn_ok = 0;

//#define	demo_x

int main( void )
{
 InitChip();
 InitAllPort();
 InitUart();
 
 //it is must select mode after power on
//power on.... 
#ifdef	demo_x
	if(EnterPress())					
		workMode = MODE_B;			//if press key select work mode b
	else
		workMode = MODE_A;	
#endif

	if(workMode == MODE_A)			//choose work mode by setting sck pin level
		SCK_SET(0);					//mode A
	else
		SCK_SET(1);					//mode B	
		
	delay_ms(2000);					//delay 2 seconds
	SCK_SET(1);						//set sck to idle 
									//end select mode
	if(workMode == MODE_A)								
		delay_ms(3000);				//wait 3 seconds for th01.then you can read data 
	while(1)
		{
		if(workMode == MODE_A)		//In a mode mcu actively reads data from TH01
			{
			Read_TH01_Amode();		//read TH01 data
			if(crc_algorithm() == dataBuf[3]);	//check checksum
			    UartMessage();				//read data ok	
			delay_ms(3000);			//3seconds interval is needed bettween two reads
			}
		else							//In b mode mcu passively receives data from TH01
			{
			//Mcu_sleep(4);			//waked up by TH01 every 60s
			Read_TH01_Bmode();		//read data after wake up by SCK PIN
			if(crc_algorithm() == dataBuf[3]);	//check checksum
			    UartMessage();				//read data ok	
			}					
		}
}
//***********************************************************
void Read_TH01_Amode(void)
{
	SCK_SET(0);				//set sck low
	delay_ms(1000);   			//wait 1s0.5s~4s)	
	SCK_SET(1);				//send one dummy clock
	delay_ms(1);				//wait 1ms(>=1ms) 
	for(byte_num=0 ; byte_num < 4 ; byte_num++)
		{
		for(bit_num = 0 ; bit_num < 8 ; bit_num++)
			{				// Clock rate recommended 20k
			SCK_SET(0);
			delay_us(25); 
			SCK_SET(1);
			delay_us(25); 
			if(READ_SDA())	//read data port
				dataBuf[byte_num] |= (0x80>>bit_num);			// 1
			else
				dataBuf [byte_num] &= ~(0x80>>bit_num);		//0
			}
		}
	SCK_SET(1);				//set sck high
}
/**************************************************************
***************************************************************/
void Read_TH01_Bmode(void)
{
	f_syn_ok = 0;
	f_level = 0;
	f_rasing_edge = 0;
	sample_cnt = 0;
	do{
		delay_us(50);						    //sampling sck every 50us
		//do{                             //The sampling time can be freely modified
                 //   }while(Wait_50us_ISR())     //Recommended use interrupt to sample
		if(READ_SDA())                                     //Check specification for specific data of bit "0/1/syn" code length
			{
			if(!f_level)
				f_rasing_edge = 1;
			f_level = 1;
			}
		else
			f_level =  0;
		sample_cnt++;

		if(f_rasing_edge)
			{	
			if(!f_syn_ok)
				{
				if((sample_cnt>100) && (sample_cnt<200))	//bit"syn" = 7500us   7500us/50us = 150
					{                                                                               
					f_syn_ok = 1;
					bit_num = 0;
					byte_num = 0;
					}
				}
			else
				{                                                                                   //bit"1" = 2500us   2500us/50us = 50
				if((sample_cnt < 10) ||(sample_cnt > 80))       //bit"0" = 1000us    1000us/50us = 20
					{
					f_syn_ok = 0;		//received data code length out of range
					}
				else
					{
					if(sample_cnt < 30)
						dataBuf [byte_num] &= ~(0x80>>bit_num);		//0
					else
						dataBuf[byte_num] |= (0x80>>bit_num);			// 1
					bit_num++;
					if(bit_num > 7)	//byte++
						{
						bit_num = 0;
						byte_num++;
						}
					}							
				}
			f_rasing_edge = 0;
			sample_cnt = 0;
			}
		}while(byte_num < 4);
	
}
//***************************************************************
byte crc_algorithm(void)					
{							
	byte crc_checksum = 0xff;							
	for (byte_num = 0 ; byte_num < 3 ; byte_num++)				
		{						
		crc_checksum ^= dataBuf[byte_num];		
		for(bit_num = 0 ; bit_num < 8 ; bit_num++)			
			{					
			if (crc_checksum & 0x01)		
				{				
				crc_checksum >>= 1;	
				crc_checksum ^= 0x8c;	
				}				
			else				
				{				
				crc_checksum >>= 1;	
				}				
			}					
		}						
	return(crc_checksum);				
}	
//**********************************************
void Mcu_sleep(byte temp)
{	
	SleepFlag = 0;
	switch(temp)
		{
		case 4:
			f_lp4 = 1;
			LPM4;
			_NOP();
			_NOP();
			f_lp4 = 0;
			break;

		case 3:
			f_lp3 = 1;
			LPM3;
			_NOP();
			_NOP();
			f_lp3 = 0;
			break;

		case 2:
			f_lp2 = 1;
			LPM2;
			_NOP();
			_NOP();
			f_lp2 = 0;
			break;

		case 1:
			f_lp1 = 1;
			LPM1;
			_NOP();
			_NOP();
			f_lp1 = 0;
			break;

		default:
			f_lp0 = 1;
			LPM0;
			_NOP();
			_NOP();
			f_lp0 = 0;
			break;
		}
}
//*****************************************************************************
void UartMessage(void)
{
	PrintfDebug("temp: ");
	//SendString("temp: ");
	if(((dataBuf[0]<<8)+dataBuf[1]) >= 0x8000)			//
		{
		PrintfDebug("-");
		itos(UartTxBuf,  (0xffff-((dataBuf[0]<<8)+dataBuf[1])), 10);
		}
	else
		{
		itos(UartTxBuf,  (dataBuf[0]<<8)+dataBuf[1], 10);
		}
	PrintfDebug(UartTxBuf);
	PrintfDebug("         humi:");
	itos(UartTxBuf,  dataBuf[2], 10);
	PrintfDebug(UartTxBuf);
	PrintfDebug("\r\n");
}
//********************************************
void	ToChar(byte  c)
{
      IFG2 &= ~UCA0TXIFG;	
      UCA0TXBUF = c;
     do{
	 	//ClrWdt();
              if((IFG2&UCA0TXIFG) == UCA0TXIFG) break;	  
			  
     	}while(1);
}
void PrintfDebug(byte  *pString)
{

   
     while(*pString != '\0') 
     {
	   ToChar(*pString++);
     }
	 
    //ToChar('\r');
    //ToChar('\n');

}
//************************************************
void SendString(const byte *ptr)
{
 byte i;
 for(i=0; ;i++)
	{
	UartTxBuf[i] = ptr[i];
	if(ptr[i]==0x0A)
		{
		_NOP();
		_NOP();
		break;
		}
		
	}
 UartTxLength = i+1;
 UartSend();
 delay_ms(20);
}
//---------------------------------------------------------------------------------------------------
const  char    AsciiTable[16] = {'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};
/*********************************************************************
** : ͵ַת
*********************************************************************/
void   itos(byte *dst, word val, byte fmt)
{
	byte i = 0;
	byte j;
	char buffer[7]; 
	
	memset(buffer, 0, sizeof(buffer));
	do
	{
		j = val%fmt;
		if(val > 0)
		{
			buffer[i++] = AsciiTable[j];
			val /= fmt; 
		}
		else
		{
			if(i==0)
			buffer[i++] = AsciiTable[j];
		}
	}while(val > 0);

	for(j = 0; j < i; j++)
	   dst[j] = buffer[i-1-j];
	
	dst[j] = 0;
 
}
/************************************************
************************************************/
void InitChip(void)
{
 WDTCTL = WDTPW + WDTHOLD;	// Stop WDT
 if (CALBC1_8MHZ==0xFF||CALDCO_8MHZ==0xFF)  //Ҫ
    while(1);

 //8MHz DCO
 BCSCTL1 = CALBC1_8MHZ;
 DCOCTL  = CALDCO_8MHZ;
 BCSCTL2 = 0x06;			//SMCLK = DCO/8
 //BCSCTL2 = 0x04;			//SMCLK = DCO/4
 //BCSCTL2 = 0x02;			//SMCLK = DCO/2
// BCSCTL2 = 0x00;			//SMCLK = DCO/1 = 1MHz
  BCSCTL3 = LFXT1S_1;			//ACLK RESERVED
/****
#ifdef   SOFTWARE_RELEASE
	 //WDTCTL = WDTPW + WDTHOLD;	// Stop WDT
	 if (CALBC1_1MHZ==0xFF||CALDCO_1MHZ==0xFF)  //Ҫ
	  {
	    _NOP();
	    while(1);
	  }

	 //1MHz DCO
	 BCSCTL1 = CALBC1_1MHZ;
	 DCOCTL  = CALDCO_1MHZ;
#else
	 BCSCTL1 = 0x87;
	 DCOCTL  = 0x2f;
#endif

	 BCSCTL2 = 0x00;			//SMCLK = DCO/1 = 1MHz
	 BCSCTL3 |= LFXT1S_2;
****/
 //жȫر
 IE1 = 0;
//_disable_interrupt();

 //Źʱ 250ms
 //WDTCTL = WDT_ADLY_1000;	//1000msʱ
 //IE1 |= WDTIE;			//Źж
 //WDTCTL = WDTPW+WDTHOLD;	//رտŹ
//----------------------------------------------------------------------------

 TA0CCR0  = 10000;			//10ms
 //TimerA0
 //---------------------------------------------------------------------
 TA0CTL   = TASSEL1+MC0;		//SMACLK/1haltģʽ
 TACCTL0  = CCIE;			//ж
 //----------------------------------------------------------------------
 //TA0CTL   = TASSEL0+MC0;		//ACLK/1Upģʽ 
 //TACCTL0  = CCIE;			//ж
 //TACCTL0 &= ~CCIE;			//ж
 //-----------------------------------------------------------------------


}

/************************************************
************************************************/
void InitAllPort(void)
{
 P1SEL = P1SEL_Data;			// 0;		//0=IO
 P1SEL2= P1SEL2_Data;			// 0;		//0=IO
 P1DIR = P1DIR_Data;			//11110000B		//0=INPUT,1=OUTPUT
 P1OUT = P1OUT_Data;			//00001110B			//OUTPUT 0+EN P1.123PULL UP
 P1IE  = P1IE_Data;				//00001110B			//EN P1.123  INT
 P1IES = P1IES_Data;			//00001110B			//½ж
 P1REN = P1REN_Data;			//00001110B		//EN P1.123 PULLUP&DOWN

 P2SEL = P2SEL_Data;			//0                        //0=IO
 P2SEL2= P2SEL2_Data;			//0                        //0=IO
 P2DIR = P2DIR_Data;			//11100111b				//0=INPUT,1=OUTPUT
 P2OUT = P2OUT_Data;			//00111100b                     //OUTPUT 0+EN P2.34 PULL UP
 P2IE  = P2IE_Data;				//00000000b                     	//dis INT
 P2IES = P2IES_Data;			//00000000b                     //Ͻж
 P2REN = P2REN_Data;			//00011000b                     	//EN P2.34 PULLUP&DOWN

 P3DIR = P3DIR_Data;			//11110011b
 P3SEL = P3SEL_Data;			//0
 P3OUT = P3OUT_Data;			//11110000b
 P3REN = P3REN_Data;			//0

 P1IFG = 0;
 P2IFG = 0;
TA0CTL &= (~TAIFG);			//־
  __enable_interrupt();		//ж
}
